import type { _NSCoder } from "./NSCoder.js";
import type { _NSCopying } from "./NSCopying.js";
import type { _NSData } from "./NSData.js";
import type { _NSMutableCopying } from "./NSMutableCopying.js";
import type { _NSObject } from "./NSObject.js";
import type { _NSString } from "./NSString.js";
import type { NSRange } from "../structs/NSRange.js";
export declare class _NSCharacterSet extends _NSObject {
    static alloc(): _NSCharacterSet;
    static new(): _NSCharacterSet;
    init(): _NSCharacterSet;
    static characterSetWithRange$(aRange: NSRange): _NSCharacterSet;
    static characterSetWithCharactersInString$(aString: _NSString): _NSCharacterSet;
    static characterSetWithBitmapRepresentation$(data: _NSData): _NSCharacterSet;
    static characterSetWithContentsOfFile$(fName: _NSString): _NSCharacterSet | null;
    static controlCharacterSet(): _NSCharacterSet;
    static whitespaceCharacterSet(): _NSCharacterSet;
    static whitespaceAndNewlineCharacterSet(): _NSCharacterSet;
    static decimalDigitCharacterSet(): _NSCharacterSet;
    static letterCharacterSet(): _NSCharacterSet;
    static lowercaseLetterCharacterSet(): _NSCharacterSet;
    static uppercaseLetterCharacterSet(): _NSCharacterSet;
    static nonBaseCharacterSet(): _NSCharacterSet;
    static alphanumericCharacterSet(): _NSCharacterSet;
    static decomposableCharacterSet(): _NSCharacterSet;
    static illegalCharacterSet(): _NSCharacterSet;
    static punctuationCharacterSet(): _NSCharacterSet;
    static capitalizedLetterCharacterSet(): _NSCharacterSet;
    static symbolCharacterSet(): _NSCharacterSet;
    static newlineCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's user subcomponent.
     */
    static URLUserAllowedCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's password subcomponent.
     */
    static URLPasswordAllowedCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's host subcomponent.
     */
    static URLHostAllowedCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's path component. ';' is a legal path character, but it is recommended that it be percent-encoded for best compatibility with NSURL (-stringByAddingPercentEncodingWithAllowedCharacters: will percent-encode any ';' characters if you pass the URLPathAllowedCharacterSet).
     */
    static URLPathAllowedCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's query component.
     */
    static URLQueryAllowedCharacterSet(): _NSCharacterSet;
    /**
     * Returns a character set containing the characters allowed in a URL's fragment component.
     */
    static URLFragmentAllowedCharacterSet(): _NSCharacterSet;
    initWithCoder$(coder: _NSCoder): _NSCharacterSet;
    characterIsMember$(aCharacter: number): boolean;
    longCharacterIsMember$(theLongChar: number): boolean;
    isSupersetOfSet$(theOtherSet: _NSCharacterSet): boolean;
    hasMemberInPlane$(thePlane: number): boolean;
    bitmapRepresentation(): _NSData;
    invertedSet(): _NSCharacterSet;
}
export interface _NSCharacterSet extends _NSCopying, _NSMutableCopying {
}
